# file: sublists.ml
# author: Bob Muller
#
# CS1101 Computer Science I
#
# Computing sublists. Illustrates:
# 1. recursion
# 2. map
# 3. anonymous functions
#
# sublists : A list -> (A list) list
#
def sublists(xs):
  if xs == []:
    return [[]]
  else:
    first = xs[0]
    rest = xs[1:]
    ans = sublists(rest)
    newPart = map(lambda ys : ys.append(first), ans)
    return ans + newPart
